
//#import <Cocoa/Cocoa.h>
#import <AVFoundation/AVFoundation.h>
#import "SampleCIView.h"

@class AllScanners, AVFBarcode;

@interface AVFBarcode : NSObject <NSWindowDelegate,AVCaptureVideoDataOutputSampleBufferDelegate> {
@private
	
	id __weak delegate;
	AllScanners *scanners;
    AVCaptureSession *captureSession;
    NSDate *lastDateScan;
    NSString *lastBarcode;

    BOOL stayOpen;
    BOOL mirrored;
    BOOL highRes;
    //double clockFrequency;
    
    IBOutlet NSPanel *previewWindow;
    IBOutlet NSView *previewView;
    IBOutlet NSImageView *imageView;
    AVCaptureVideoPreviewLayer *previewLayer;
    
    CALayer *rectangleLayer;

}

@property (retain, atomic) AVCaptureSession *captureSession;
@property (retain, nonatomic) NSDate *lastDateScan;
@property (retain, nonatomic) AllScanners *scanners;
@property (retain, nonatomic) NSString *lastBarcode;
@property (retain, nonatomic) AVCaptureVideoPreviewLayer *previewLayer;
@property (retain, nonatomic) CALayer *rectangleLayer;

@property (weak, nonatomic) id delegate;
@property (assign) BOOL mirrored;
@property (assign) BOOL stayOpen;
@property (retain, nonatomic) NSArray *topLevelObjects;

//+(instancetype) alloc __attribute__((unavailable("alloc not available, call sharedInstance instead")));
//-(instancetype) init __attribute__((unavailable("init not available, call sharedInstance instead")));
//+(instancetype) new __attribute__((unavailable("new not available, call sharedInstance instead")));


+ (AVFBarcode *)sharedInstance;

- (void)scanForBarcodeWindow:(NSWindow *)aWindow;

- (void)scanBarcode;

- (BOOL)closeiSight;

+ (AVCaptureDevice *)selectAndOpenVideoDevice:(NSString *)prefsDefaultKey;

- (void)foundBarcode:(NSString *)aBarcode;  //Let the program know a barcode was found

@end


@protocol BarcodeScanning
- (void)gotBarcode:(NSString *)barcode;
@end

@interface NSObject (BarcodeScanningProtocolOptional)
- (void)iSightWillClose;
@end


